#ifndef _VIVOTEK_CONST_DEFINITION_HEADER_
#define	_VIVOTEK_CONST_DEFINITION_HEADER_

// The following constants are for string, the length does not include the null terminate
// so if you want to declare a string, you must add 1
#define	VIVO_MAX_HOST_NAME_LEN			128			// host name or IP address (including IPV6)
#define	VIVO_MAX_USER_NAME_LEN			64
#define	VIVO_MAX_USER_PASSWORD_LEN		64
#define	VIVO_MAX_MOPM_WINNAME_LEN		14			// the window name for motion detection or private mask window
#define	VIVO_MAX_PRESET_NAME_LEN		64			// the preset location name length
#define	VIVO_MAX_URL_PATH_LEN			1024
#define	VIVO_MAX_URL_EXTRA_LEN			1024
#define	VIVO_MAX_DOMAIN_NAME			1024
#define	VIVO_MAX_IP_ADDRESS				39		// for IP V4 and V6, it should not be used as host name length


// the following is for number constant
#define	VIVO_MAX_DI_NUM					8			// the maximum number of Digital input in a camera
#define	VIVO_MAX_DO_NUM					8			// the maximum number of digital output in a camera
#define VIVO_MAX_MD_NUM					5			// the maximum number of motion detection window

#define VIVO_MAX_RF_NUM					1			// the maximum number of remote focus window
#define VIVO_MAX_ST_NUM					4			// the maximum number of video stream



// enumeration
typedef enum
{
	eVivoEvn_Motion,		
	eVivoEvn_Visignal,
	eVivoEvn_Event_DI,
	eVivoEvn_Event_DO,
	eVivoEvn_Event_PIR,
	eVivoEvn_Event_NoSuchEvent,
} EVIVO_EVENT_TYPE;



#endif // _VIVOTEK_CONST_DEFINITION_HEADER_