#ifndef AVSYNCCONVERTAVIWRAPPER_H
#define AVSYNCCONVERTAVIWRAPPER_H

#include <windows.h>
#include "datapacketdef.h"
#include "AvSynchronizer.h"

#define AV_ERRMSGBUF_SIZE 200  // Error meesage buffer size

typedef struct tAvSyncConvertAviWrapperParam
{
	HWND    hDlg;
	HWND    hDisplay;
	HBITMAP hBMP;

	LPSTATUSCALLBACK  pfStatus;
	LPDISPLAYCALLBACK pfDisplay;
	LPSTATUSCALLBACK  pfAviStatus;
	LPDISPLAYCALLBACK pfAviCaption;
	
	DWORD dwStatusContext;
	DWORD dwDisplayContext;
	DWORD dwAviStatusContext; 
	DWORD dwAviCaptionContext;

}TAVSYNCAVIWRAPPERPARAM;  // Structure : parameters

class CAvSyncConvertAviWrapper
{
private:
	HANDLE m_hAvSync;           // AvSynchronizer handle
	HANDLE m_hPlaybackChannel;  // Playback channel handle
	HANDLE m_hAviChannel;       // Avi channel handle

	char m_szErrMsgBuf[AV_ERRMSGBUF_SIZE];  // Error message buffer

	TAVSYNCAVIWRAPPERPARAM m_tParam;

	SCODE InitialModule();
	SCODE ReleaseModule();
	SCODE CreateChannel();
	SCODE DeleteChannel();
	SCODE CreateAVIChannel();
	SCODE DeleteAVIChannel();

public:
	CAvSyncConvertAviWrapper(HWND hDlg, HWND hDisplay, HBITMAP hBMP, LPSTATUSCALLBACK pfStatus, 
		                                                             LPDISPLAYCALLBACK pfDisplay, 
																	 LPSTATUSCALLBACK pfAviStatus, 
																	 LPDISPLAYCALLBACK pfAviCaption, 
																	 DWORD dwStatusContext, 
																	 DWORD dwDisplayContext,
																	 DWORD dwAviStatusContext, 
																	 DWORD dwAviCaptionContext);
	
	~CAvSyncConvertAviWrapper();

	SCODE Play();
	SCODE Stop();
	SCODE Pause(BOOL bPause);
	SCODE Forward(DWORD dwFast, DWORD dwSlow);
	SCODE NextFrame();
	SCODE UpdatePlaybackChannelMediaType(DWORD dwMediaType);
	SCODE InputDataPacketToChannel(TMediaDataPacketInfoV3 *ptPacketInfoV3);
	SCODE WaitAVQueueEmpty();
	
	SCODE StartAVIChannel(char *pszSaveAviDirectoyPath);
	SCODE StopAVIChannel();
	SCODE InputDataPacketToAVIChannel(TMediaDataPacketInfoV3 *ptPacketInfoV3);
	SCODE SetVideoCompressorParam();
	SCODE SetAudioCompressorParam();
};

#endif  // AVSYNCCONVERTAVIWRAPPER_H