#ifndef AVSYNCPLAYBACKWRAPPER_H
#define AVSYNCPLAYBACKWRAPPER_H

#include <windows.h>
#include "datapacketdef.h"
#include "AvSynchronizer.h"

#define AV_ERRMSGBUF_SIZE 200  // Error meesage buffer size


typedef struct tAvSyncMultiPlaybackWrapperParam
{
	HWND    hDlg;
	HWND    *phDisplay;
	HBITMAP hBMP;

	LPSTATUSCALLBACK  pfStatus;
	LPDISPLAYCALLBACK pfDisplay;
	
	DWORD dwStatusContext;
	DWORD dwDisplayContext;

}TAVSYNCPLAYBACKWRAPPERPARAM;  // Structure : parameters

class CAvSyncMultiPlaybackWrapper
{
private:
	HANDLE m_hAvSync;             // AvSynchronizer handle
	HANDLE *m_phPlaybackChannel;  // Playback channel handle

	DWORD m_dwChannelNum;

	char m_szErrMsgBuf[AV_ERRMSGBUF_SIZE];  // Error message buffer

	TAVSYNCPLAYBACKWRAPPERPARAM m_tParam;

	SCODE InitialModule();
	SCODE ReleaseModule();
	SCODE CreateChannel(DWORD dwCHIndex);
	SCODE DeleteChannel(DWORD dwCHIndex);

public:
	CAvSyncMultiPlaybackWrapper(HWND hDlg, HWND ahDisplay[], DWORD dwChannelNum, HBITMAP hBMP, LPSTATUSCALLBACK pfStatus, LPDISPLAYCALLBACK pfDisplay, DWORD dwStatusContext, DWORD dwDisplayContext);
	~CAvSyncMultiPlaybackWrapper();

	SCODE Play(DWORD dwCHIndex);
	SCODE Stop(DWORD dwCHIndex);
	SCODE Pause(DWORD dwCHIndex, BOOL bPause);
	SCODE Forward(DWORD dwCHIndex, DWORD dwFast, DWORD dwSlow);
	SCODE NextFrame(DWORD dwCHIndex);
	SCODE UpdatePlaybackChannelMediaType(DWORD dwCHIndex, DWORD dwMediaType);
	SCODE InputDataPacketToChannel(DWORD dwCHIndex, TMediaDataPacketInfoV3 *ptPacketInfoV3);
	SCODE WaitAVQueueEmpty(DWORD dwCHIndex);
};

#endif  // AVSYNCPLAYBACKWRAPPER_H