// Display32ChannelsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Display32Channels.h"
#include "Display32ChannelsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#include "datapacketdef.h"
#include "parsedatapacket.h"
#include "AvSyncMultiPlaybackWrapper.h"
#include "DataPacketParser.h"

#define AV_OBJECT_NUM         4    // Number of CAvSyncMultiPlaybackWrapper objects
#define MAX_CHANNEL_NUM       8    // Max number of channels which one CAvSyncMultiPlaybackWrapper object owns
#define TIMESTAMP_BUF_SIZE    200  // Timestamp buffer size
#define CHANNELINDEX_BUF_SIZE 10   // Channel index buffer size


DWORD WINAPI ReadRawFileThread(LPVOID lpParam);  // Read raw file thread

SCODE __stdcall AvSynchronizerStatusCallBack(DWORD dwContext, DWORD dwStatusCode, DWORD dwParam1, DWORD dwParam2);  // AvSynchronizer Status callback function
SCODE __stdcall AvSynchronizerDisplayCallBack(DWORD dwContext, TDISPLAYINFO* ptDisplayInfo);                        // AvSynchronizer Display callback function


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CDisplay32ChannelsDlg dialog




CDisplay32ChannelsDlg::CDisplay32ChannelsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDisplay32ChannelsDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDisplay32ChannelsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_FILEPATH, m_editboxFilePath);
	DDX_Control(pDX, IDC_BUTTON_PLAY, m_buttonPlay);
	DDX_Control(pDX, IDC_BUTTON_PAUSE, m_buttonPause);
	DDX_Control(pDX, IDC_BUTTON_STOP, m_buttonStop);
}

BEGIN_MESSAGE_MAP(CDisplay32ChannelsDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_OPENFILE, &CDisplay32ChannelsDlg::OnBnClickedButtonOpenfile)
	ON_BN_CLICKED(IDC_BUTTON_PLAY, &CDisplay32ChannelsDlg::OnBnClickedButtonPlay)
	ON_BN_CLICKED(IDC_BUTTON_PAUSE, &CDisplay32ChannelsDlg::OnBnClickedButtonPause)
	ON_BN_CLICKED(IDC_BUTTON_STOP, &CDisplay32ChannelsDlg::OnBnClickedButtonStop)
	
	ON_MESSAGE(WM_USER_RESETDLGBUTTON, &CDisplay32ChannelsDlg::OnResetDlgButton)  // Specific message map : WM_USER_RESETDLGBUTTON -> OnResetDlgButton
END_MESSAGE_MAP()


// CDisplay32ChannelsDlg message handlers

BOOL CDisplay32ChannelsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	
	// Initialization (Appended)
	//
	m_bPause = FALSE;
	m_bStop  = FALSE;

	m_hBMP = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_MARK));

	m_hReadRawFileThread = NULL;

	// According to the hardware capability (especially CPU), user can create two or more AvSynchronizer objects to enhance the performance.
	// For example, if the computer is equipped with dual-core CPU, user can gain better performance by creating four AvSynchronizer objects.
	// In this sample code, we create four AvSynchronizer objects to deal with the 32 playback channels.
	//	
	m_pphDisplay = new HWND* [AV_OBJECT_NUM];

	DWORD dwAvObjIndex;

	// Create arrays with "HWND" type for each AvSynchronizer object 
	for	(dwAvObjIndex = 0; dwAvObjIndex < AV_OBJECT_NUM; ++dwAvObjIndex)
	{
		m_pphDisplay[dwAvObjIndex] = new HWND [MAX_CHANNEL_NUM];  // Create an array to store the display windows handles
	}

	DWORD dwCHIndex, dwIDCount = 0;
	
	// Get the display window handles for each channel
	for	(dwAvObjIndex = 0; dwAvObjIndex < AV_OBJECT_NUM; ++dwAvObjIndex)
	{
		for	(dwCHIndex = 0; dwCHIndex < MAX_CHANNEL_NUM; ++dwCHIndex)
		{
			m_pphDisplay[dwAvObjIndex][dwCHIndex] = GetDlgItem(IDC_STATIC_DISPLAY1  + dwIDCount)->GetSafeHwnd();

			++dwIDCount;
		}
	}

	DWORD dwStartCHIndex = 1;  // Set start channel index = 1	
	
	m_ppAVWrappers = new CAvSyncMultiPlaybackWrapper* [AV_OBJECT_NUM];

	for	(dwAvObjIndex = 0; dwAvObjIndex < AV_OBJECT_NUM; ++dwAvObjIndex)
	{
		// Construct a CAvSyncMultiPlaybackWrapper object
		// Here we pass a channel index to be a display context, and use it as an start channel index of each AvSynchronizer object.
		//
		m_ppAVWrappers[dwAvObjIndex] = new CAvSyncMultiPlaybackWrapper(this->GetSafeHwnd(), m_pphDisplay[dwAvObjIndex], MAX_CHANNEL_NUM, m_hBMP, AvSynchronizerStatusCallBack, AvSynchronizerDisplayCallBack, (DWORD)this, dwStartCHIndex);

		dwStartCHIndex += MAX_CHANNEL_NUM;
	}

	m_buttonPlay.EnableWindow(FALSE);
	m_buttonStop.EnableWindow(FALSE);
	m_buttonPause.EnableWindow(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDisplay32ChannelsDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDisplay32ChannelsDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDisplay32ChannelsDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CDisplay32ChannelsDlg::OnBnClickedButtonOpenfile()
{
	char szFileFilter[] = "All Files (*.*)|*.*||";
	
	CFileDialog fDlg(TRUE, NULL, NULL, OFN_FILEMUSTEXIST | OFN_HIDEREADONLY, szFileFilter);

	if	(fDlg.DoModal() == IDOK)
	{
		m_strFilePath = fDlg.GetPathName();

		m_editboxFilePath.SetWindowText(m_strFilePath.GetBuffer());

		m_buttonPlay.EnableWindow(TRUE);
	}
}

void CDisplay32ChannelsDlg::OnBnClickedButtonPlay()
{
	DWORD dwAvObjIndex, dwCHIndex;

	// Start each playback channel
	for	(dwAvObjIndex = 0; dwAvObjIndex < AV_OBJECT_NUM; ++dwAvObjIndex)
	{
		for	(dwCHIndex = 0; dwCHIndex < MAX_CHANNEL_NUM; ++dwCHIndex)
		{
			m_ppAVWrappers[dwAvObjIndex]->Play(dwCHIndex);  // Play
		}
	}

	m_bStop = FALSE;

	m_hReadRawFileThread = CreateThread(NULL, 0, ReadRawFileThread, this, 0, &m_dwThreadID);  // Start "ReadRawFileThread"
	
	m_buttonPlay.EnableWindow(FALSE);
	m_buttonPause.EnableWindow(TRUE);
	m_buttonStop.EnableWindow(TRUE);
}

void CDisplay32ChannelsDlg::OnBnClickedButtonPause()
{		
	if	(!m_bPause)  // Pause
	{
		m_buttonPause.SetWindowText("Resume");		

		m_bPause = TRUE;
	}
	else  // Resume
	{
		m_buttonPause.SetWindowText("Pause");
		m_buttonStop.EnableWindow(TRUE);

		m_bPause = FALSE;
	}

	DWORD dwAvObjIndex, dwCHIndex;

	// Pause or Resume each playback channel
	for	(dwAvObjIndex = 0; dwAvObjIndex < AV_OBJECT_NUM; ++dwAvObjIndex)
	{
		for	(dwCHIndex = 0; dwCHIndex < MAX_CHANNEL_NUM; ++dwCHIndex)
		{
			m_ppAVWrappers[dwAvObjIndex]->Pause(dwCHIndex, m_bPause);  // Pause or Resume
		}
	}
}

void CDisplay32ChannelsDlg::OnBnClickedButtonStop()
{
	m_buttonStop.EnableWindow(FALSE);	
	m_buttonPlay.EnableWindow(TRUE);
	m_buttonPause.EnableWindow(FALSE);

	m_bStop = TRUE;
	
	DWORD dwAvObjIndex, dwCHIndex;
	
	// Stop each playback channel
	for	(dwAvObjIndex = 0; dwAvObjIndex < AV_OBJECT_NUM; ++dwAvObjIndex)
	{
		for	(dwCHIndex = 0; dwCHIndex < MAX_CHANNEL_NUM; ++dwCHIndex)
		{
			m_ppAVWrappers[dwAvObjIndex]->Stop(dwCHIndex);  // Stop
		}
	}

	if	(m_hReadRawFileThread)
	{
		// If the playback channel is paused, the thread cannot return
		if	(m_bPause)
		{
			m_bPause = FALSE;

			// Resume each playback channel
			for	(dwAvObjIndex = 0; dwAvObjIndex < AV_OBJECT_NUM; ++dwAvObjIndex)
			{
				for	(dwCHIndex = 0; dwCHIndex < MAX_CHANNEL_NUM; ++dwCHIndex)
				{
					m_ppAVWrappers[dwAvObjIndex]->Pause(dwCHIndex, m_bPause);  // Resume
				}
			}
		}

		// Wait for the "ReadRawFileThread"
		WaitForSingleObject(m_hReadRawFileThread, INFINITE);
	}
}

void CDisplay32ChannelsDlg::OnDestroy()
{
	DWORD dwAvObjIndex, dwCHIndex;

	if	(m_hReadRawFileThread != NULL)
	{	
		// If the playback channel is paused, the thread cannot return
		if	(m_bPause)
		{
			m_bPause = FALSE;

			// Resume each playback channel
			for	(dwAvObjIndex = 0; dwAvObjIndex < AV_OBJECT_NUM; ++dwAvObjIndex)
			{
				for	(dwCHIndex = 0; dwCHIndex < MAX_CHANNEL_NUM; ++dwCHIndex)
				{
					m_ppAVWrappers[dwAvObjIndex]->Pause(dwCHIndex, m_bPause);  // Resume
				}
			}
		}

		if	(!m_bStop)
		{	
			m_bStop = TRUE;

			// Wait for the "ReadRawFileThread"
			WaitForSingleObject(m_hReadRawFileThread, INFINITE);
		}

		// Close thread handle
		CloseHandle(m_hReadRawFileThread);
	}	

	for	(dwAvObjIndex = 0; dwAvObjIndex < AV_OBJECT_NUM; ++dwAvObjIndex)
	{
		delete m_ppAVWrappers[dwAvObjIndex];  // Destroy the CAvSyncMultiPlaybackWrapper objects
	}

	delete [] m_ppAVWrappers;

	for	(dwAvObjIndex = 0; dwAvObjIndex < AV_OBJECT_NUM; ++dwAvObjIndex)
	{
		for	(dwCHIndex = 0; dwCHIndex < MAX_CHANNEL_NUM; ++dwCHIndex)
		{
			::DeleteObject(m_pphDisplay[dwAvObjIndex][dwCHIndex]);  // Destroy display window handles
		}

		delete [] m_pphDisplay[dwAvObjIndex];
	}

	delete [] m_pphDisplay;

	if	(m_hBMP != NULL)
	{
		::DeleteObject(m_hBMP);
	}
	
	CDialog::OnDestroy();
}

// Reset button state in dialog
LRESULT CDisplay32ChannelsDlg::OnResetDlgButton(WPARAM, LPARAM)
{
	m_buttonPlay.EnableWindow(TRUE);
	m_buttonPause.EnableWindow(FALSE);
	m_buttonPause.SetWindowText("Pause");
	m_buttonStop.EnableWindow(FALSE);

	return 1;
}

// Function     : ReadRawFileThread (Thread)
// Description  : Read data from raw file and input the data to playback channel
// Parameter    : 
//              | [in] lpParam @Parameter passed to the thread
// Return value :
//              | 0 @Success
//              | 1 @Fail
//
DWORD WINAPI ReadRawFileThread(LPVOID lpParam)
{	
	CDisplay32ChannelsDlg *pDlg = (CDisplay32ChannelsDlg *)lpParam;
	
	// Construct a CDataPacketParser object
	CDataPacketParser *pParser = new CDataPacketParser(pDlg->m_strFilePath.GetBuffer());  

	DWORD dwStreamType = pParser->GetMediaStreamType();

	DWORD dwAvObjIndex, dwCHIndex;

	for	(dwAvObjIndex = 0; dwAvObjIndex < AV_OBJECT_NUM; ++dwAvObjIndex)
	{
		for	(dwCHIndex = 0; dwCHIndex < MAX_CHANNEL_NUM; ++dwCHIndex)
		{
			pDlg->m_ppAVWrappers[dwAvObjIndex]->UpdatePlaybackChannelMediaType(dwCHIndex, dwStreamType);
		}
	}

	TMediaDataPacketInfoV3 tPacketInfo;
	
	SCODE scRet = S_OK;

	while	(!pDlg->m_bStop && (scRet == S_OK))
	{
		// Get one media data packet info form file
		scRet = pParser->GetOneMediaDataPacketInfo(&tPacketInfo);		

		// Input the data packet to playback channel
		DWORD dwAvObjIndex, dwCHIndex;

		for	(dwAvObjIndex = 0; dwAvObjIndex < AV_OBJECT_NUM; ++dwAvObjIndex)
		{
			for	(dwCHIndex = 0; dwCHIndex < MAX_CHANNEL_NUM; ++dwCHIndex)
			{
				scRet = pDlg->m_ppAVWrappers[dwAvObjIndex]->InputDataPacketToChannel(dwCHIndex, &tPacketInfo);
			}
		}

		pParser->EmptyBuffer();
	}

	if	(!pDlg->m_bStop)
	{
		// User does not stop the channel. 
		// Wait until the audio and video elements in AvSynchronizer's queue are all played then stop the channel
		pDlg->m_bStop = TRUE;

		DWORD dwAvObjIndex, dwCHIndex;

		for	(dwAvObjIndex = 0; dwAvObjIndex < AV_OBJECT_NUM; ++dwAvObjIndex)
		{
			for	(dwCHIndex = 0; dwCHIndex < MAX_CHANNEL_NUM; ++dwCHIndex)
			{
				pDlg->m_ppAVWrappers[dwAvObjIndex]->WaitAVQueueEmpty(dwCHIndex);

				pDlg->m_ppAVWrappers[dwAvObjIndex]->Stop(dwCHIndex);
			}
		}
	}
	else
	{
		// User stop the channel by pressing the stop button.
		for	(dwAvObjIndex = 0; dwAvObjIndex < AV_OBJECT_NUM; ++dwAvObjIndex)
		{
			for	(dwCHIndex = 0; dwCHIndex < MAX_CHANNEL_NUM; ++dwCHIndex)
			{
				pDlg->m_ppAVWrappers[dwAvObjIndex]->Stop(dwCHIndex);
			}
		}
	}

	delete pParser;  // Destroy CDataPacketParser object

	// Reset dialog buttons
	::PostMessage(pDlg->GetSafeHwnd(), WM_USER_RESETDLGBUTTON, 0, 0);

	return 0;
}

// This callback function is used to notify the application the status of the AvSynchronizer, the calling convention must be stdcall
SCODE __stdcall AvSynchronizerStatusCallBack(DWORD dwContext, DWORD dwStatusCode, DWORD dwParam1, DWORD dwParam2)
{
	// Use switch-case to handle different status code
	switch	(dwStatusCode)
	{
	case AVSYNCHRONIZER_STATUSCODE_DECODE_ERROR:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_MEMALLOC_ERROR:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_FRAME_SIZE_CHG:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_AUDIO_START:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_AUDIO_STOP:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_MOTION:
		{
			break;
		}
	case AVSYNCHRONIZER_NEW_IMAGE:
		{
			break;
		}
	case AVSYNCHRONIZER_FIRST_IMAGE:
		{
			break;
		}
	default:
		{
			break;
		}
	}

	return S_OK;
}

// This callback function is used to notify the application before displaying, the calling convention must be stdcall
SCODE __stdcall AvSynchronizerDisplayCallBack(DWORD dwContext, TDISPLAYINFO* ptDisplayInfo)
{
	DWORD dwCHIndex = dwContext;

	HDC hDC = ptDisplayInfo->hDC;

	SetBkMode(hDC, TRANSPARENT);

	SetTextColor(hDC, RGB(255, 255, 255));
	
	// Print timestamp on the top-right of display window	
	if	((ptDisplayInfo->dwFlag & DIF_RESUMING) == 0)
	{
		char szTimeStampBuf[TIMESTAMP_BUF_SIZE] = "\0";

		struct tm *ptmTimeStamp = (struct tm *)ptDisplayInfo->DrawTime;	

		sprintf_s(szTimeStampBuf, TIMESTAMP_BUF_SIZE, "%d/%02d/%02d %02d:%02d:%02d", ptmTimeStamp->tm_year + 1900, 
			                                                                         ptmTimeStamp->tm_mon + 1, 
																				     ptmTimeStamp->tm_mday,
																					 ptmTimeStamp->tm_hour, 
																					 ptmTimeStamp->tm_min, 
																					 ptmTimeStamp->tm_sec);

		SIZE szTimeStampBufSize;

		GetTextExtentPoint32(hDC, szTimeStampBuf, strlen(szTimeStampBuf), &szTimeStampBufSize);

		TextOut(hDC, ptDisplayInfo->dwWidth - szTimeStampBufSize.cx - 5, ptDisplayInfo->ptOrigin.y, szTimeStampBuf, strlen(szTimeStampBuf));

		// Print channel index on the buttom-right of display window
		char szCHIndexBuf[CHANNELINDEX_BUF_SIZE] = "\0";

		sprintf_s(szCHIndexBuf, CHANNELINDEX_BUF_SIZE, "%d", dwCHIndex);

		SIZE szCHIndexBufSize;

		GetTextExtentPoint32(hDC, szCHIndexBuf, strlen(szCHIndexBuf), &szCHIndexBufSize);

		SetTextColor(hDC, RGB(255, 255, 0));

		TextOut(hDC, ptDisplayInfo->dwWidth - 20, ptDisplayInfo->dwHeight - 15, szCHIndexBuf, strlen(szCHIndexBuf));
	}

	return S_OK;
}
