// DisplayAndGetRawDataWithLiveChannelDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DisplayAndGetRawDataWithLiveChannel.h"
#include "DisplayAndGetRawDataWithLiveChannelDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#include "DataBrokerConnectWrapper.h"
#include "AvSyncLiveGetRawWrapper.h"
#include "SetupConnectionDlg.h"

#define ERRMSGBUF_SIZE     200       // Error message buffer size 
#define TIMESTAMP_BUF_SIZE 200       // Timestamp buffer size
#define PATHBUF_SIZE       MAX_PATH  // Max size of decode directory path buffer

SCODE __stdcall DataBrokerStatusCallBack(DWORD dwContext, TDataBrokerStatusType tStatusType, PVOID pvParam1, PVOID pvParam2);  // DataBroker Status callback function
SCODE __stdcall DataBrokerAVCallBack(DWORD dwContext,TMediaDataPacketInfo *pMediaDataPacket);                                  // DtatBroker AV callback function
SCODE __stdcall AvSynchronizerStatusCallBack(DWORD dwContext, DWORD dwStatusCode, DWORD dwParam1, DWORD dwParam2);             // AvSynchronizer Status callback function
SCODE __stdcall AvSynchronizerDisplayCallBack(DWORD dwContext, TDISPLAYINFO* ptDisplayInfo);                                   // AvSynchronizer Display callback function
SCODE __stdcall AvSynchronizerFrameDecodeCallback(DWORD dwContext, TMediaType tFrameType, TFRAMEINFOEX *tFrameInfoEx);         // AvSynchronizer Decode Frame callback function


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CDisplayAndGetRawDataWithLiveChannelDlg dialog




CDisplayAndGetRawDataWithLiveChannelDlg::CDisplayAndGetRawDataWithLiveChannelDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDisplayAndGetRawDataWithLiveChannelDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDisplayAndGetRawDataWithLiveChannelDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_HOSTIPADDRESS, m_editboxHostIPAddress);
	DDX_Control(pDX, IDC_EDIT_SERVERTYPE, m_editboxServerType);
	DDX_Control(pDX, IDC_EDIT_PORT, m_editboxPort);
	DDX_Control(pDX, IDC_BUTTON_START, m_buttonStart);
	DDX_Control(pDX, IDC_BUTTON_STOP, m_buttonStop);
	DDX_Control(pDX, IDC_BUTTON_SETUPCONNECTION, m_buttonSetupconnection);
	DDX_Control(pDX, IDC_EDIT_SAVEDECODEDATALOCATION, m_editboxSaveDecodeDataLocation);
	DDX_Control(pDX, IDC_BUTTON_SETUPDECODEDATALOCATION, m_buttonSetupDecodeDataLocation);
	DDX_Control(pDX, IDC_CHECK_USERGB, m_chkboxUseRGB);
	DDX_Control(pDX, IDC_CHECK_USEYUV, m_chkboxUseYUV);
}

BEGIN_MESSAGE_MAP(CDisplayAndGetRawDataWithLiveChannelDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_SETUPCONNECTION, &CDisplayAndGetRawDataWithLiveChannelDlg::OnBnClickedButtonSetupconnection)
	ON_BN_CLICKED(IDC_BUTTON_START, &CDisplayAndGetRawDataWithLiveChannelDlg::OnBnClickedButtonStart)
	ON_BN_CLICKED(IDC_BUTTON_STOP, &CDisplayAndGetRawDataWithLiveChannelDlg::OnBnClickedButtonStop)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_SETUPDECODEDATALOCATION, &CDisplayAndGetRawDataWithLiveChannelDlg::OnBnClickedButtonSetupdecodedatalocation)
	ON_BN_CLICKED(IDC_CHECK_USERGB, &CDisplayAndGetRawDataWithLiveChannelDlg::OnBnClickedCheckUsergb)
	ON_BN_CLICKED(IDC_CHECK_USEYUV, &CDisplayAndGetRawDataWithLiveChannelDlg::OnBnClickedCheckUseyuv)
END_MESSAGE_MAP()


// CDisplayAndGetRawDataWithLiveChannelDlg message handlers

BOOL CDisplayAndGetRawDataWithLiveChannelDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Initialization (Appended)
	//
	m_buttonStart.EnableWindow(FALSE);
	m_buttonStop.EnableWindow(FALSE);
	m_chkboxUseYUV.SetCheck(BST_CHECKED);

	m_pszSaveDirectoryPath = new char [PATHBUF_SIZE];
	
	memset(m_pszSaveDirectoryPath, 0, PATHBUF_SIZE);

	m_hDisplay = GetDlgItem(IDC_STATIC_DISPLAY)->GetSafeHwnd();

	m_hBMP = LoadBitmap(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDB_MARK));

	// Construct a CDataBrokerConnectWrapper object
	m_pDBWrapper = new CDataBrokerConnectWrapper(DataBrokerStatusCallBack, DataBrokerAVCallBack, (DWORD)this, (DWORD)this);  
	
	// Construct a CAvSyncLiveGetRawWrapper object
	m_pAVWrapper = new CAvSyncLiveGetRawWrapper(this->GetSafeHwnd(), m_hDisplay, m_hBMP, AvSynchronizerStatusCallBack, AvSynchronizerDisplayCallBack, (DWORD)this, (DWORD)this);  

	InitializeCriticalSection(&m_CS);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDisplayAndGetRawDataWithLiveChannelDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDisplayAndGetRawDataWithLiveChannelDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDisplayAndGetRawDataWithLiveChannelDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CDisplayAndGetRawDataWithLiveChannelDlg::OnBnClickedButtonSetupconnection()
{
	// Call setup connection modal dialog
	CSetupConnectionDlg scDlg;

	if	(scDlg.DoModal() == IDOK)
	{
		// Get connection info from setup connection modal dialog
		m_strIPAddr     = scDlg.m_strIPAddr;
		m_strServerType = scDlg.m_strServerType;
		m_strHttpPort   = scDlg.m_strHttpPort;
		m_strUserID     = scDlg.m_strUserID;
	    m_strPassword   = scDlg.m_strPassword;
		m_wHttpPort     = (WORD)scDlg.m_dwHttpPort;
		
		// Show IP address, Server type, and port
		m_editboxHostIPAddress.SetWindowText(m_strIPAddr.GetBuffer());
		m_editboxServerType.SetWindowText(m_strServerType.GetBuffer());
		m_editboxPort.SetWindowText(m_strHttpPort.GetBuffer());

		m_buttonStart.EnableWindow(TRUE);
	}
}

void CDisplayAndGetRawDataWithLiveChannelDlg::OnBnClickedButtonStart()
{
	UpdateData(TRUE);

	if	(m_chkboxUseRGB.GetCheck() == BST_CHECKED)
	{
		m_pAVWrapper->SetDecodeOptions(PF_RGB24, AvSynchronizerFrameDecodeCallback, (DWORD)this);
	}
	else if	(m_chkboxUseYUV.GetCheck() == BST_CHECKED)
	{
		m_pAVWrapper->SetDecodeOptions(PF_YUV, AvSynchronizerFrameDecodeCallback, (DWORD)this);
	}
	else
	{
		return;
	}

	m_buttonStart.EnableWindow(FALSE);
	m_buttonStop.EnableWindow(TRUE);
	m_buttonSetupconnection.EnableWindow(FALSE);
	m_buttonSetupDecodeDataLocation.EnableWindow(FALSE);
	m_chkboxUseRGB.EnableWindow(FALSE);
	m_chkboxUseYUV.EnableWindow(FALSE);

	// Start live channel
	m_pAVWrapper->Start();

	// Connect to remote server
	m_pDBWrapper->Connect(m_wHttpPort, m_strIPAddr.GetBuffer(), m_strServerType.GetBuffer(), m_strUserID.GetBuffer(), m_strPassword.GetBuffer());
}

void CDisplayAndGetRawDataWithLiveChannelDlg::OnBnClickedButtonStop()
{
	m_buttonStart.EnableWindow(TRUE);
	m_buttonStop.EnableWindow(FALSE);
	m_buttonSetupconnection.EnableWindow(TRUE);
	m_buttonSetupDecodeDataLocation.EnableWindow(TRUE);
	m_chkboxUseRGB.EnableWindow(TRUE);
	m_chkboxUseYUV.EnableWindow(TRUE);

	// Stop live channel
	m_pAVWrapper->Stop();

	// Disconnect from remote server
	m_pDBWrapper->Disconnect();
}

void CDisplayAndGetRawDataWithLiveChannelDlg::OnBnClickedCheckUsergb()
{
	if	(m_chkboxUseRGB.GetCheck() == BST_CHECKED)
	{
		m_chkboxUseYUV.SetCheck(BST_UNCHECKED);
	}
	else
	{
		m_chkboxUseYUV.SetCheck(BST_CHECKED);
	}
}

void CDisplayAndGetRawDataWithLiveChannelDlg::OnBnClickedCheckUseyuv()
{
	if	(m_chkboxUseYUV.GetCheck() == BST_CHECKED)
	{
		m_chkboxUseRGB.SetCheck(BST_UNCHECKED);
	}
	else
	{
		m_chkboxUseRGB.SetCheck(BST_CHECKED);
	}
}

void CDisplayAndGetRawDataWithLiveChannelDlg::OnBnClickedButtonSetupdecodedatalocation()
{
	char szDirectoryPath[PATHBUF_SIZE] = "\0";

	BROWSEINFO tBrowseInfo;

	tBrowseInfo.hwndOwner      = this->GetSafeHwnd();
	tBrowseInfo.pidlRoot       = NULL;
	tBrowseInfo.pszDisplayName = szDirectoryPath;
	tBrowseInfo.lpszTitle      = "Please select decode directory path";
	tBrowseInfo.ulFlags        = BIF_RETURNONLYFSDIRS;
	tBrowseInfo.lpfn           = NULL;
    tBrowseInfo.lParam         = 0;
    tBrowseInfo.iImage         = 0;

	LPITEMIDLIST pItemIDList = SHBrowseForFolder(&tBrowseInfo);
	
	if (pItemIDList == NULL)
	{
        return;
	}

    if (!SHGetPathFromIDList(pItemIDList, szDirectoryPath))
	{
		return;
	}

	strcpy_s(m_pszSaveDirectoryPath, PATHBUF_SIZE, szDirectoryPath);
	
	m_editboxSaveDecodeDataLocation.SetWindowText(szDirectoryPath);

	// Release ITEMIDLIST use IMalloc interface	
	IMalloc *pIMalloc = NULL;

	if	(SUCCEEDED(SHGetMalloc(&pIMalloc)))
	{
		pIMalloc->Free(pItemIDList);
		
		pIMalloc->Release();
	}
}

void CDisplayAndGetRawDataWithLiveChannelDlg::OnDestroy()
{
	delete m_pDBWrapper;  // Delete an CDataBrokerConnectWrapper object

	delete m_pAVWrapper;  // Delete an CAvSyncLiveGetRawWrapper object

	if	(m_hDisplay != NULL)
	{
		::DestroyWindow(m_hDisplay);
	}

	if	(m_hBMP != NULL)
	{
		::DeleteObject(m_hBMP);
	}

	delete [] m_pszSaveDirectoryPath;

	DeleteCriticalSection(&m_CS);

	CDialog::OnDestroy();
}

// This callback function is used to report the status of DataBroker object, the calling convention must be stdcall
SCODE __stdcall DataBrokerStatusCallBack(DWORD dwContext, TDataBrokerStatusType tStatusType, PVOID pvParam1, PVOID pvParam2)
{
	CDisplayAndGetRawDataWithLiveChannelDlg *pDlg = (CDisplayAndGetRawDataWithLiveChannelDlg *)dwContext;

	char szErrMsgBuf[ERRMSGBUF_SIZE] = "\0";

	switch	(tStatusType)
	{
	case eOnConnectionInfo:  // DataBroker connection information
		{
			sprintf_s(szErrMsgBuf, sizeof(szErrMsgBuf), "Connect to remote server successfully\n");

			OutputDebugString(szErrMsgBuf);

			PTDataBrokerConnInfo ptDBConnInfo;

			ptDBConnInfo = (PTDataBrokerConnInfo) pvParam1;

			// Update AvSynchronizer live channel settings	
			if	(ptDBConnInfo->dwMediaType == (emtAudio|emtVideo))
			{
				pDlg->m_pAVWrapper->UpdateChannelMediaType(AVSYNCHRONIZER_MEDIATYPE_AUDIO_VIDEO);
			}
			else if	(ptDBConnInfo->dwMediaType == emtVideo)
			{
				pDlg->m_pAVWrapper->UpdateChannelMediaType(AVSYNCHRONIZER_MEDIATYPE_VIDEO_ONLY);
			}
			else
			{
				pDlg->m_pAVWrapper->UpdateChannelMediaType(AVSYNCHRONIZER_MEDIATYPE_AUDIO_ONLY);
			}

			break;
		}
	case eOnAuthFailed:  // Authentication failed
		{
			sprintf_s(szErrMsgBuf, sizeof(szErrMsgBuf), "Authentication failed!\n");

			OutputDebugString(szErrMsgBuf);

			break;
		}
	case eOnStartMediaChannel:  // DataBroker connection begins to receive media stream
		{
			sprintf_s(szErrMsgBuf, sizeof(szErrMsgBuf), "Begins to receive media stream from remote server\n");

			OutputDebugString(szErrMsgBuf);
			
			break;
		}
	case eOnStopped:  // DataBroker Connection stopped
		{
			sprintf_s(szErrMsgBuf, sizeof(szErrMsgBuf), "Disconnect from remote server successfully\n");

			OutputDebugString(szErrMsgBuf);

			// Reset button state in dialog
			pDlg->m_buttonStart.EnableWindow(TRUE);
			pDlg->m_buttonStop.EnableWindow(FALSE);
			pDlg->m_buttonSetupconnection.EnableWindow(TRUE);

			// Show bitmap
			pDlg->m_pAVWrapper->UpdateChannelShowBMP();

			break;
		}
	case eOnServiceUnavailable:  // The connections to remote server already exceed upper limit.
		{
			sprintf_s(szErrMsgBuf, sizeof(szErrMsgBuf), "Connections to remote server already exceed the upper limit!\n");

			OutputDebugString(szErrMsgBuf);

			// Show bitmap
			pDlg->m_pAVWrapper->UpdateChannelShowBMP();

			break;
		}
	default:
		{
			break;
		}
	}

	return S_OK;
}

// This callback function is used to receive audio and video frames, the calling convention must be stdcall
SCODE __stdcall DataBrokerAVCallBack(DWORD dwContext, TMediaDataPacketInfo *pMediaDataPacket)
{
	CDisplayAndGetRawDataWithLiveChannelDlg *pDlg = (CDisplayAndGetRawDataWithLiveChannelDlg *)dwContext;

	char szErrMsgBuf[ERRMSGBUF_SIZE] = "\0";

	SCODE scRet;

	EnterCriticalSection(&pDlg->m_CS);  // Enter critical section

	// Input the media data packet into AvSynchronizer live channel
	scRet = pDlg->m_pAVWrapper->InputEncodedMediaFrame(pMediaDataPacket);	

	if	(scRet == AVSYNCHRONIZER_E_QUEUE_FULL)
	{
		sprintf_s(szErrMsgBuf, sizeof(szErrMsgBuf), "AvSynchronizer queue full!\n");

		OutputDebugString(szErrMsgBuf);

		LeaveCriticalSection(&pDlg->m_CS);  // Leave critical section

		return DATABROKER_S_FRAME_NOT_HANDLED;
	}

	LeaveCriticalSection(&pDlg->m_CS);  // Leave critical section

	return S_OK;
}

// This callback function is used to notify the application the status of the AvSynchronizer, the calling convention must be stdcall
SCODE __stdcall AvSynchronizerStatusCallBack(DWORD dwContext, DWORD dwStatusCode, DWORD dwParam1, DWORD dwParam2)
{
	// Use switch-case to handle different status code
	switch	(dwStatusCode)
	{
	case AVSYNCHRONIZER_STATUSCODE_DECODE_ERROR:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_MEMALLOC_ERROR:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_FRAME_SIZE_CHG:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_AUDIO_START:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_AUDIO_STOP:
		{
			break;
		}
	case AVSYNCHRONIZER_STATUSCODE_MOTION:
		{
			break;
		}
	case AVSYNCHRONIZER_NEW_IMAGE:
		{
			break;
		}
	case AVSYNCHRONIZER_FIRST_IMAGE:
		{
			break;
		}
	default:
		{
			break;
		}
	}

	return S_OK;
}

// This callback function is used to notify the application before displaying, the calling convention must be stdcall
SCODE __stdcall AvSynchronizerDisplayCallBack(DWORD dwContext, TDISPLAYINFO* ptDisplayInfo)
{	
	HDC hDC = ptDisplayInfo->hDC;

	SetBkMode(hDC, TRANSPARENT);

	SetTextColor(hDC, RGB(255, 255, 255));

	char szTimeStampBuf[TIMESTAMP_BUF_SIZE] = "\0";
	
	if	((ptDisplayInfo->dwFlag & DIF_CONNECTING) == 0)
	{
		// Print timestamp on the top-right of display window	
		if	((ptDisplayInfo->dwFlag & DIF_RESUMING) == 0)
		{
			struct tm *ptmTimeStamp = (struct tm *)ptDisplayInfo->DrawTime;	

			sprintf_s(szTimeStampBuf, TIMESTAMP_BUF_SIZE, "%d/%02d/%02d %02d:%02d:%02d", ptmTimeStamp->tm_year + 1900, 
																						 ptmTimeStamp->tm_mon + 1, 
																						 ptmTimeStamp->tm_mday,
																						 ptmTimeStamp->tm_hour, 
																						 ptmTimeStamp->tm_min, 
																						 ptmTimeStamp->tm_sec);

			SIZE szTimeStampBufSize;

			GetTextExtentPoint32(hDC, szTimeStampBuf, strlen(szTimeStampBuf), &szTimeStampBufSize);

			TextOut(hDC, ptDisplayInfo->dwWidth - szTimeStampBufSize.cx - 5, ptDisplayInfo->ptOrigin.y, szTimeStampBuf, strlen(szTimeStampBuf));
		}
	}
	else
	{
		sprintf_s(szTimeStampBuf, TIMESTAMP_BUF_SIZE, "Connecting...");

		TextOut(hDC, ptDisplayInfo->ptOrigin.x, ptDisplayInfo->ptOrigin.y, szTimeStampBuf, strlen(szTimeStampBuf));
	}
	
	return S_OK;
}

// This callback function is used to notify the application the decoded audio or video frame, the calling convention must be stdcall
SCODE __stdcall AvSynchronizerFrameDecodeCallback(DWORD dwContext, TMediaType tFrameType, TFRAMEINFOEX *tFrameInfoEx)
{
	CDisplayAndGetRawDataWithLiveChannelDlg *pDlg = (CDisplayAndGetRawDataWithLiveChannelDlg *)dwContext;
	
	FILE *pRawVideoFile = NULL;
	FILE *pRawAudioFile = NULL;

	char szFilePathBuf[PATHBUF_SIZE] = "\0";

	EPIXELFORMAT ePixelFormat = EPIXELFORMAT(pDlg->m_pAVWrapper->m_dwDecodeFormat);

	if	(tFrameType == AVSYNCHRONIZER_MEDIATYPE_VIDEO_ONLY)  // Save video raw data
	{
		switch	(ePixelFormat)
		{
		case PF_RGB24:
			{
				sprintf_s(szFilePathBuf, PATHBUF_SIZE, "%s\\Decode Video.rgb", pDlg->m_pszSaveDirectoryPath);

				break;
			}
		case PF_YUV:
			{
				sprintf_s(szFilePathBuf, PATHBUF_SIZE, "%s\\Decode Video.yuv", pDlg->m_pszSaveDirectoryPath);

				break;
			}
		default:
			{
				break;
			}
		}

		fopen_s(&pRawVideoFile, szFilePathBuf, "ab");

		if	(pRawVideoFile != NULL)
		{
			fwrite(tFrameInfoEx->tF.tVideoFrame.pbyPicture, sizeof(BYTE), tFrameInfoEx->tF.tVideoFrame.dwSize, pRawVideoFile);

			fclose(pRawVideoFile);
		}
	}
	else if	(tFrameType == AVSYNCHRONIZER_MEDIATYPE_AUDIO_ONLY)  // Save audio raw data
	{
		sprintf_s(szFilePathBuf, PATHBUF_SIZE, "%s\\Decode Audio.pcm", pDlg->m_pszSaveDirectoryPath);

		fopen_s(&pRawAudioFile, szFilePathBuf, "ab");

		if	(pRawAudioFile != NULL)
		{
			fwrite(tFrameInfoEx->tF.tAudioFrame.pbySound, sizeof(BYTE), tFrameInfoEx->tF.tAudioFrame.dwSize, pRawAudioFile);

			fclose(pRawAudioFile);
		}
	}

	return S_OK;
}