#ifndef AVSYNCPLAYBACKGETRAWWRAPPER_H
#define AVSYNCPLAYBACKGETRAWWRAPPER_H

#include <windows.h>
#include "datapacketdef.h"
#include "AvSynchronizer.h"


#define AV_ERRMSGBUF_SIZE 200  // Error meesage buffer size

typedef struct tAvSyncPlaybackGetRawParam
{
	HWND    hDlg;
	HWND    hDisplay;
	HBITMAP hBMP;

	LPSTATUSCALLBACK  pfStatus;
	LPDISPLAYCALLBACK pfDisplay;
	
	DWORD dwStatusContext;
	DWORD dwDisplayContext;

}TAVSYNCPLAYBACKGETRAWPARAM;  // Structure : parameters

class CAvSyncPlaybackGetRawWrapper
{
private:
	HANDLE m_hAvSync;           // AvSynchronizer handle
	HANDLE m_hPlaybackChannel;  // Playback channel handle

	char m_szErrMsgBuf[AV_ERRMSGBUF_SIZE];  // Error message buffer

	TAVSYNCPLAYBACKGETRAWPARAM m_tParam;

	SCODE InitialModule();
	SCODE ReleaseModule();
	SCODE CreateChannel();
	SCODE DeleteChannel();

public:
	DWORD m_dwDecodeFormat;  // Decode data format

	CAvSyncPlaybackGetRawWrapper(HWND hDlg, HWND hDisplay, HBITMAP hBMP, LPSTATUSCALLBACK pfStatus, LPDISPLAYCALLBACK pfDisplay, DWORD dwStatusContext, DWORD dwDisplayContext);
	~CAvSyncPlaybackGetRawWrapper();

	SCODE Play();
	SCODE Stop();
	SCODE Pause(BOOL bPause);
	SCODE Forward(DWORD dwFast, DWORD dwSlow);
	SCODE NextFrame();
	SCODE UpdatePlaybackChannelMediaType(DWORD dwMediaType);
	SCODE InputDataPacketToChannel(TMediaDataPacketInfoV3 *ptPacketInfoV3);
	SCODE WaitAVQueueEmpty();

	SCODE SetDecodeOptions(DWORD dwFormat, LPDECODEFRAMECALLBACK_EX pfDecodeFrameEx, DWORD dwDecodeFrameContext);
};

#endif  // AVSYNCPLAYBACKGETRAWWRAPPER_H