#ifndef AVSYNCLIVEGETMULTIPLERAWWRAPPER_H
#define AVSYNCLIVEGETMULTIPLERAWWRAPPER_H

#include <windows.h>
#include "datapacketdef.h"
#include "AvSynchronizer.h"

#define AV_ERRMSGBUF_SIZE 200  // Error message buffer size 


typedef struct tAvSyncLiveGetMultipleRawWrapperParam
{
	HWND    hDlg;
	HWND    hDisplay;
	HBITMAP hBMP;

	LPSTATUSCALLBACK  pfStatus;
	LPDISPLAYCALLBACK pfDisplay;
	
	DWORD dwStatusContext;
	DWORD dwDisplayContext;

}TAVSYNCLIVEGETMULTIPLERAWWRAPPERPARAM;  // Structure : parameters

class CAvSyncLiveGetMultipleRawWrapper
{
private:
	HANDLE m_hAvSync;       // AvSynchronizer handle
	HANDLE m_hLiveChannel;  // Live channel handle

	char m_szErrMsgBuf[AV_ERRMSGBUF_SIZE];  // Error message buffer

	TAVSYNCLIVEGETMULTIPLERAWWRAPPERPARAM m_tParam;

	SCODE InitialModule();
	SCODE ReleaseModule();
	SCODE CreateChannel();
	SCODE DeleteChannel();

public:
	DWORD m_dwDecodeFormat;      // Decode data format
	DWORD m_dwNextDecodeFormat;  // Next decode data format

	CAvSyncLiveGetMultipleRawWrapper(HWND hDlg, HWND hDisplay, HBITMAP hBMP, LPSTATUSCALLBACK pfStatus, LPDISPLAYCALLBACK pfDisplay, DWORD dwStatusContext, DWORD dwDisplayContext);
	~CAvSyncLiveGetMultipleRawWrapper();

	SCODE Start();
	SCODE Stop();

	SCODE UpdateChannelMediaType(DWORD dwMediaType);
	SCODE UpdateChannelShowBMP();
	SCODE InputEncodedMediaFrame(TMediaDataPacketInfo *pMediaDataPacket);
	SCODE SetDecodeOptions(DWORD dwFormat, LPDECODEFRAMECALLBACK_EX pfDecodeFrameEx, DWORD dwDecodeFrameContext);

	SCODE SetDecodeOptions(DWORD dwFormat, DWORD dwNextFormat, LPDECODEFRAMECALLBACK_EX pfDecodeFrameEx, DWORD dwDecodeFrameContext);
};

#endif  // AVSYNCLIVEGETMULTIPLERAWWRAPPER_H