#ifndef AVSYNCPLAYBACKWRAPPER_H
#define AVSYNCPLAYBACKWRAPPER_H

#include <windows.h>
#include "datapacketdef.h"
#include "AvSynchronizer.h"

#define AV_ERRMSGBUF_SIZE 200  // Error meesage buffer size


typedef struct tAvSyncPlaybackWrapperParam
{
	HWND    hDlg;
	HWND    hDisplay;
	HBITMAP hBMP;

	LPSTATUSCALLBACK  pfStatus;
	LPDISPLAYCALLBACK pfDisplay;
	
	DWORD dwStatusContext;
	DWORD dwDisplayContext;

}TAVSYNCPLAYBACKWRAPPERPARAM;  // Structure : parameters

class CAvSyncPlaybackWrapper
{
private:
	HANDLE m_hAvSync;           // AvSynchronizer handle
	HANDLE m_hPlaybackChannel;  // Playback channel handle

	char m_szErrMsgBuf[AV_ERRMSGBUF_SIZE];  // Error message buffer

	TAVSYNCPLAYBACKWRAPPERPARAM m_tParam;

	SCODE InitialModule();
	SCODE ReleaseModule();
	SCODE CreateChannel();
	SCODE DeleteChannel();

public:
	CAvSyncPlaybackWrapper(HWND hDlg, HWND hDisplay, HBITMAP hBMP, LPSTATUSCALLBACK pfStatus, LPDISPLAYCALLBACK pfDisplay, DWORD dwStatusContext, DWORD dwDisplayContext);
	~CAvSyncPlaybackWrapper();

	SCODE Play();
	SCODE Stop();
	SCODE Pause(BOOL bPause);
	SCODE Forward(DWORD dwFast, DWORD dwSlow);
	SCODE NextFrame();
	SCODE UpdatePlaybackChannelMediaType(DWORD dwMediaType);
	SCODE InputDataPacketToChannel(TMediaDataPacketInfoV3 *ptPacketInfoV3);
	SCODE WaitAVQueueEmpty();
};

#endif  // AVSYNCPLAYBACKWRAPPER_H