// ControlwithMouse.cpp : Defines the entry point for the application.
//

#include "ControlwithMouse.h"

#define MAX_LOADSTRING 100

const DWORD g_kMaxElapse = 3;
const DWORD g_kAutoPVElapse = 100;

CMPUT          *g_pMPUT = NULL;
TFISHEYEVIEWER g_tViewer;
POINTS         g_MouseLBtnBeginPos;
POINTS         g_MouseLBtnCheckPos;
POINTS         g_MouseMovePos;
DWORD          g_MouseElapseX;
DWORD          g_MouseElapseY;
HCURSOR        g_hCursHand;
RECT           g_WindowRoi;

// Fisheye Stream Function Declaration
// ----------------------------------------------------------------------------------------------------
void connect();
void disconnect();
// ----------------------------------------------------------------------------------------------------

// Fisheye Viewer Function Declaration
// ----------------------------------------------------------------------------------------------------
void updateViewer(TFISHEYEVIEWER *ptViewer);
// ----------------------------------------------------------------------------------------------------

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_CONTROLWITHMOUSE, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_CONTROLWITHMOUSE));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_CONTROLWITHMOUSE));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_CONTROLWITHMOUSE);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, 800, 600, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   g_tViewer.hViewerWindow = hWnd;
   
   g_pMPUT = new CMPUT(hWnd);
   if (!g_pMPUT)
   {
	   return FALSE;
   }

   g_hCursHand = LoadCursor(NULL, IDC_HAND);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	//PAINTSTRUCT ps;
	//HDC hdc;

	switch (message)
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			if (g_pMPUT)
			{
				delete g_pMPUT;
				g_pMPUT = NULL;
			}
			DestroyWindow(hWnd);
			break;

		// Fisheye Stream Operation
		// ----------------------------------------------------------------------------------------------------
		case ID_FISHEYE_STREAM_CONNECT:
			connect();
			break;
		case ID_FISHEYE_STREAM_DISCONNECT:
			disconnect();
			break;
		// ----------------------------------------------------------------------------------------------------

		// Fisheye Viewer Function Operation: Select present mode
		// ----------------------------------------------------------------------------------------------------
		case ID_FISHEYE_PM_SINGLE_SOURCE_STRETCH:
			g_tViewer.dwPresentMode = FEPRESENTMODE_SINGLE_SOURCE_STRETCH;
			g_tViewer.dwUpdateFlags = FEUPDATEVIEWER_PRESENTMODE;
			updateViewer(&g_tViewer);
			break;
		case ID_FISHEYE_PM_SINGLE_PARTIALCORRECTION:
			g_tViewer.dwPresentMode = FEPRESENTMODE_SINGLE_PERSPECT_VIEW;
			g_tViewer.dwUpdateFlags = FEUPDATEVIEWER_PRESENTMODE;
			updateViewer(&g_tViewer);
			break;
		case ID_FISHEYE_PM_TRIPLE:
			g_tViewer.dwPresentMode = FEPRESENTMODE_TRIPLE;
			g_tViewer.dwUpdateFlags = FEUPDATEVIEWER_PRESENTMODE;
			updateViewer(&g_tViewer);
			break;
		case ID_FISHEYE_PM_QUAD_UNCALIBRATE:
			g_tViewer.dwPresentMode = FEPRESENTMODE_QUAD_WITH_SOURCE_CONSTRAINPROP;
			g_tViewer.dwUpdateFlags = FEUPDATEVIEWER_PRESENTMODE;
			updateViewer(&g_tViewer);
			break;
		// ----------------------------------------------------------------------------------------------------

		// Fisheye Viewer Function Operation: Select viewer angle
		// ----------------------------------------------------------------------------------------------------
		case ID_FISHEYE_VIEWERANGLE_180:
			g_tViewer.dwViewerAngle = FEVIEWERANGLE_180;
			g_tViewer.dwUpdateFlags = FEUPDATEVIEWER_VIEWERANGLE;
			updateViewer(&g_tViewer);
			break;
		case ID_FISHEYE_VIEWERANGLE_360:
			g_tViewer.dwViewerAngle = FEVIEWERANGLE_360;
			g_tViewer.dwUpdateFlags = FEUPDATEVIEWER_VIEWERANGLE;
			updateViewer(&g_tViewer);
			break;
		case ID_FISHEYE_VIEWERANGLE_360I:
			g_tViewer.dwViewerAngle = FEVIEWERANGLE_360I;
			g_tViewer.dwUpdateFlags = FEUPDATEVIEWER_VIEWERANGLE;
			updateViewer(&g_tViewer);
			break;
		// ----------------------------------------------------------------------------------------------------

		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		//hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
		//EndPaint(hWnd, &ps);
		break;
	case WM_SIZE:
		GetClientRect(hWnd, &g_WindowRoi);
		break;

	// Fisheye Viewer Function Operation: Control with mouse
	// ----------------------------------------------------------------------------------------------------
	case WM_LBUTTONDOWN:
		// Get the coordinate of cursor.
		g_MouseLBtnBeginPos = MAKEPOINTS(lParam);

		// Reset the elapsed distance.
		g_MouseElapseX = 0;
		g_MouseElapseY = 0;
		break;
	case WM_LBUTTONUP:		
		if ((g_MouseElapseX < g_kMaxElapse) && (g_MouseElapseY < g_kMaxElapse))
		{
			// Clik-on-image control
			// ----------------------------------------------------------------------------------------------------
			// Perform pan, tilt and rotate control in the quadrant. 
			// The quadrant is specified by BeginPoint and EndPoint.
			g_tViewer.tCtrlCommands.dwCtrlFlags          = FEPTZRCONTROL_CLICK | FEPTZRCONTROL_PTR;
			g_tViewer.tCtrlCommands.bClick               = TRUE;
			g_tViewer.tCtrlCommands.PTRParams.BeginPoint = MAKEPOINTS(lParam);
			g_tViewer.tCtrlCommands.PTRParams.EndPoint   = MAKEPOINTS(lParam);

			g_tViewer.dwUpdateFlags = FEUPDATEVIEWER_CONTROLCOMMANDS;
			updateViewer(&g_tViewer);
			// ----------------------------------------------------------------------------------------------------			
			
			// Set focus to the quadrant which is specified by AnchorPoint.
			g_tViewer.tCtrlCommands.dwCtrlFlags = FEPTZRCONTROL_ANCHOR;			
			g_tViewer.tCtrlCommands.AnchorPoint = MAKEPOINTS(lParam);

			g_tViewer.dwUpdateFlags = FEUPDATEVIEWER_CONTROLCOMMANDS;
			updateViewer(&g_tViewer);
		}
		break;
	case WM_LBUTTONDBLCLK:
		// Get the coordinate of cursor.
		g_MouseLBtnBeginPos = MAKEPOINTS(lParam);

		// Reset the control commands in the quadrant which is specified by FocusPoint.
		g_tViewer.tCtrlCommands.dwCtrlFlags            = FEPTZRCONTROL_RESET;
		g_tViewer.tCtrlCommands.ResetParams.FocusPoint = g_MouseLBtnBeginPos;
		g_tViewer.tCtrlCommands.ResetParams.bResetP    = TRUE;
		g_tViewer.tCtrlCommands.ResetParams.bResetT    = TRUE;
		g_tViewer.tCtrlCommands.ResetParams.bResetZ    = TRUE;
		g_tViewer.tCtrlCommands.ResetParams.bResetR    = TRUE;

		g_tViewer.dwUpdateFlags = FEUPDATEVIEWER_CONTROLCOMMANDS;
		updateViewer(&g_tViewer);
		break;
	case WM_MOUSEMOVE:
		// Get the coordinate of cursor.
		g_MouseMovePos = MAKEPOINTS(lParam);

		// Just use the hand-style cursor to enhance the visual effect when controlling...
		if ((g_MouseMovePos.x > g_WindowRoi.left) && (g_MouseMovePos.x < g_WindowRoi.right) && 
			(g_MouseMovePos.y > g_WindowRoi.top) && (g_MouseMovePos.y < g_WindowRoi.bottom))
		{
			SetCursor(g_hCursHand);
		}

		if (wParam == MK_LBUTTON)
		{
			// Get the coordinate of cursor. (The left mouse button is down)
			g_MouseLBtnCheckPos = MAKEPOINTS(lParam);

			// Drag-and-drop control
			// ----------------------------------------------------------------------------------------------------
			if ((g_MouseElapseX > g_kMaxElapse) || (g_MouseElapseY > g_kMaxElapse))
			{
				//if (g_MouseElapseX > g_kAutoPVElapse)
				//{
				//	// Perform auto panoramic view in the quadrant					
				//	long Speed = 2, offsetX = g_MouseLBtnCheckPos.x - g_MouseLBtnBeginPos.x;					
				//	g_tViewer.tCtrlCommands.dwCtrlFlags = FEPTZRCONTROL_AUTOSPEED;
				//	g_tViewer.tCtrlCommands.autoSpeed = offsetX > 0 ? -Speed : Speed;
				//}
				//else
				{
					// Perform pan, tilt and rotate control in the quadrant. 
					// The quadrant is specified by BeginPoint and EndPoint.
					g_tViewer.tCtrlCommands.dwCtrlFlags          = FEPTZRCONTROL_CLICK | FEPTZRCONTROL_PTR;
					g_tViewer.tCtrlCommands.bClick               = FALSE;
					g_tViewer.tCtrlCommands.PTRParams.BeginPoint = g_MouseLBtnBeginPos;
					g_tViewer.tCtrlCommands.PTRParams.EndPoint   = g_MouseLBtnCheckPos;
				}

				g_tViewer.dwUpdateFlags = FEUPDATEVIEWER_CONTROLCOMMANDS;
				updateViewer(&g_tViewer);
			}			
			// ----------------------------------------------------------------------------------------------------

			// Update the elapsed distance.
			g_MouseElapseX += abs(g_MouseLBtnCheckPos.x - g_MouseLBtnBeginPos.x);
			g_MouseElapseY += abs(g_MouseLBtnCheckPos.y - g_MouseLBtnBeginPos.y);

			// Update the begin position!
			g_MouseLBtnBeginPos = g_MouseLBtnCheckPos;
		}
		break;
	case WM_MOUSEWHEEL:
		// Perform zoom control in the quadrant which is specified by FocusPoint.
		g_tViewer.tCtrlCommands.dwCtrlFlags        = FEPTZRCONTROL_Z;
		g_tViewer.tCtrlCommands.ZParams.FocusPoint = g_MouseMovePos;
		g_tViewer.tCtrlCommands.ZParams.DeltaSteps = GET_WHEEL_DELTA_WPARAM(wParam) / 16;

		g_tViewer.dwUpdateFlags = FEUPDATEVIEWER_CONTROLCOMMANDS;
		updateViewer(&g_tViewer);
		break;
	// ----------------------------------------------------------------------------------------------------

	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

// Fisheye Stream Function Definition
// ----------------------------------------------------------------------------------------------------
void connect()
{
	if (g_pMPUT)
	{
		BOOL bSupportFisheye;
		bSupportFisheye = g_pMPUT->FisheyeCheckSupport();
		if (!bSupportFisheye)
		{
			MessageBox(g_tViewer.hViewerWindow, "Not support fisheye render!", NULL, (MB_OK | MB_ICONWARNING));
			return;
		}

		g_pMPUT->FisheyeEnableRender();

		g_pMPUT->Connect();
	}
}

void disconnect()
{
	if (g_pMPUT)
	{
		g_pMPUT->Disconnect();
	}
}
// ----------------------------------------------------------------------------------------------------

// Fisheye Viewer Function Definition
// ----------------------------------------------------------------------------------------------------
void updateViewer(TFISHEYEVIEWER *ptViewer)
{
	if (g_pMPUT)
	{
		g_pMPUT->FisheyeUpdateViewer(ptViewer);
	}
}
// ----------------------------------------------------------------------------------------------------
