#ifndef __MPUT_H__
#define __MPUT_H__

#include "AVSynchronizer_Fisheye.h"

class CMPUT
{
public:
	CMPUT(HWND hShowWnd);
	~CMPUT();

	SCODE Connect();
	SCODE Disconnect();
	BOOL FisheyeCheckSupport();
	SCODE FisheyeEnableRender();
	SCODE FisheyeRegisterViewer(TFISHEYEVIEWER *ptFisheyeViewer);
	SCODE FisheyeUpdateViewer(TFISHEYEVIEWER *ptFisheyeViewer);
	SCODE FisheyeRemoveViewer(TFISHEYEVIEWER *ptFisheyeViewer);
	SCODE FisheyeGetCurrentViewerSnapshot(TFISHEYESNAPSHOT *ptFisheyeSnapshot, LPCSTR pszDirectory, BOOL bOrginalSize);
	SCODE FisheyeGetCurrentViewerDisplay(HDC hDC, TFISHEYECURRENTDISPLAY *ptFisheyeCurrentDisplay);
	SCODE FisheyeGetViewerPresentParameters(TFISHEYEPRESENTPARAMS *ptFisheyePresentParams);
	SCODE FisheyeSetViewerPresentParameters(TFISHEYEPRESENTPARAMS *ptFisheyePresentParams);
	SCODE FisheyeUpdateRotateOptions(TFISHEYEROTATEOPTIONS *ptRotateOptions);

public:
	HWND   m_hShowWnd;
	HANDLE m_hASChannel;
	HANDLE m_hDBConnect;
	BOOL   m_bConnected;

private:
	void internalInitial();
	void internalRelease();
	SCODE internalInitialAS();
	SCODE internalInitialDB();	
	SCODE internalReleaseAS();
	SCODE internalReleaseDB();

private:
	HANDLE m_hAS;	
	HANDLE m_hDB;	
};

#endif  // __MPUT_H__
