#include "ServerManager.h"
#include "GetModelNameBlock.h"


int main(int argc, char *argv[])
{
	SCODE scRet;
	HANDLE hServerMgr = NULL;
	TVersionInfo tVerInfo = {SRVMNGR_VERSION_MAJOR, SRVMNGR_VERSION_MINOR, SRVMNGR_VERSION_BUILD, SRVMNGR_VERSION_REVISION};
	HANDLE hDevice = NULL;
	char szHostName[MAX_HOSTNAME_LEN] = {0};
	char szUserName[MAX_USERNAME_LEN] = {0};
	char szPassword[MAX_PASSWORD_LEN] = {0};
	char szHttpPort[MAX_HTTPPORT_LEN] = {0};
	char szTimeout[MAX_TIMEOUT_LEN] = {0};
	char szModel[MAX_PATH + 1] = {0};
	DWORD dwHttpPort = 0;
	DWORD dwTimeout = 0;
	TSRVMNGR_DEV_PROPERTY tDevProperty;
	char szModelName[MAX_PATH + 1] = {0};
	DWORD dwSize = MAX_PATH;

	scRet = ServerManager_Initial(&hServerMgr, CONST_MAX_DEVICE, 0, &tVerInfo);	
	
	if (IS_FAIL(scRet))
	{
		printf("ServerManager_Initial failed with error %x\n", scRet);
		return -1;
	}

	scRet = ServerManager_CreateDevice(hServerMgr, &hDevice);
	
	if (IS_FAIL(scRet))
	{
		printf("ServerManager_CreateDevice failed with error %x\n", scRet);
		return -1;
	}

	printf("Please input server ip : ");
	gets(szHostName);

	printf("Please input server user name : ");
	gets(szUserName);

	printf("Please input server password : ");
	gets(szPassword);

	printf("Please input http port : ");
	gets(szHttpPort);

	printf("Please input timeout value (sec): ");
	gets(szTimeout);

	dwHttpPort = (DWORD) atoi(szHttpPort);
	dwTimeout = (DWORD) atoi(szTimeout) * 1000;

	memset(&tDevProperty, 0 , sizeof(tDevProperty));
	strcpy(tDevProperty.tServerProperty.szHost, szHostName);
	strcpy(tDevProperty.tServerProperty.szUserName, szUserName);
	strcpy(tDevProperty.tServerProperty.szPassword, szPassword);
	tDevProperty.tServerProperty.dwHttpPort = dwHttpPort;
	tDevProperty.tServerProperty.dwTimeout = dwTimeout;

	scRet = ServerManager_SetDeviceProperty(hDevice, &tDevProperty);
	
	if (IS_FAIL(scRet))
	{
		printf("ServerManager_SetDeviceProperty failed with error %x\n", scRet);
		return -1;
	}

	scRet = ServerManager_OpenDeviceBlock(hDevice, szModel, MAX_PATH);
	
	if (IS_FAIL(scRet))
	{
		printf("ServerManager_OpenDeviceBlock failed with error: %x\n", scRet);
		return -1;
	}
	else
	{
		printf("Model = %s\n", szModel);
	}

	// Get model name
	scRet = ServerManager_GetValueByName(hDevice, "system_info_modelname", szModelName, &dwSize);

	if (IS_FAIL(scRet))
	{
		printf("ServerManager_GetValueByName failed with error: %x\n", scRet);
		return -1;
	}
	
	// Model Name
	printf("Model Name = %s\n", szModelName);

	scRet = ServerManager_DeleteDevice(&hDevice);

	if (IS_FAIL(scRet))
	{
		printf("ServerManager_DeleteDevice failed with error %x\n", scRet);
		return -1;
	}

	scRet = ServerManager_Release(&hServerMgr);
	
	if (IS_FAIL(scRet))
	{
		printf("ServerManager_Release failed with error %x\n", scRet);
		return -1;
	}

	hDevice = NULL;
	hServerMgr = NULL;
	
	return 0;
}